
#ifndef __DEFAULT_PLUGINS_COMPLETION_COMPLETION_H__
#define __DEFAULT_PLUGINS_COMPLETION_COMPLETION_H__

#include <glib.h>
#include <glib-object.h>
#include <valide-0.0.h>

G_BEGIN_DECLS


#define TYPE_COMPLETION_PLUGIN (completion_plugin_get_type ())
#define COMPLETION_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_COMPLETION_PLUGIN, CompletionPlugin))
#define COMPLETION_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_COMPLETION_PLUGIN, CompletionPluginClass))
#define IS_COMPLETION_PLUGIN(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_COMPLETION_PLUGIN))
#define IS_COMPLETION_PLUGIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_COMPLETION_PLUGIN))
#define COMPLETION_PLUGIN_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_COMPLETION_PLUGIN, CompletionPluginClass))

typedef struct _CompletionPlugin CompletionPlugin;
typedef struct _CompletionPluginClass CompletionPluginClass;
typedef struct _CompletionPluginPrivate CompletionPluginPrivate;

#define TYPE_DOCUMENT_PROVIDER (document_provider_get_type ())
#define DOCUMENT_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCUMENT_PROVIDER, DocumentProvider))
#define DOCUMENT_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DOCUMENT_PROVIDER, DocumentProviderClass))
#define IS_DOCUMENT_PROVIDER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCUMENT_PROVIDER))
#define IS_DOCUMENT_PROVIDER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DOCUMENT_PROVIDER))
#define DOCUMENT_PROVIDER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DOCUMENT_PROVIDER, DocumentProviderClass))

typedef struct _DocumentProvider DocumentProvider;
typedef struct _DocumentProviderClass DocumentProviderClass;
typedef struct _DocumentProviderPrivate DocumentProviderPrivate;

struct _CompletionPlugin {
	GObject parent_instance;
	CompletionPluginPrivate * priv;
};

struct _CompletionPluginClass {
	GObjectClass parent_class;
};

struct _DocumentProvider {
	GObject parent_instance;
	DocumentProviderPrivate * priv;
};

struct _DocumentProviderClass {
	GObjectClass parent_class;
};


GType completion_plugin_get_type (void);
CompletionPlugin* completion_plugin_new (void);
CompletionPlugin* completion_plugin_construct (GType object_type);
GType register_plugin (void);
GType document_provider_get_type (void);
DocumentProvider* document_provider_new (ValideSymbolsCache* symbols, ValideDocumentManager* documents);
DocumentProvider* document_provider_construct (GType object_type, ValideSymbolsCache* symbols, ValideDocumentManager* documents);
ValideDocumentManager* document_provider_get_documents (DocumentProvider* self);
ValideSymbolsCache* document_provider_get_symbols (DocumentProvider* self);
ValideAbstractTextDocument* document_provider_get_document (DocumentProvider* self);


G_END_DECLS

#endif
